<template>
    <section>
        <h2>Your Wallet</h2>

        <div class="card bg-transparent" style="min-height: 4rem;">
            <div class="card-body">
                <h3 class="card-title">Earnings</h3>

                <span class="float-right h3"><span v-if="loading"><i class="fas fa-spinner fa-spin"></i></span><span v-else>Br {{ remainingBalance }}</span></span>
                <br>
                <router-link to="/publisher/withdraw-request" class="btn btn-primary font-weight-bold mt-4">Request Payout</router-link>
            </div>
        </div>

        <hr>

        <h4>Transactions</h4>

        <table class="table table-hover" style="width: 99%">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Date</th>
                <th scope="col">Amount</th>
                <th scope="col">Status</th>
            </tr>
            </thead>
            <tbody v-if="!loading">
            <tr v-for="withdrawRequest of withdrawRequests">
                <th scope="row">{{ withdrawRequest.id }}</th>
                <td>{{ withdrawRequest.created_at }}</td>
                <td>Br {{ Number(withdrawRequest.amount).toFixed(2) }}</td>
                <td>{{ withdrawRequest.status }}</td>
            </tr>
            </tbody>
        </table>

        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span v-else-if="fail">
                    {{ fail.message }}
                    <br><a href="#" class="btn btn-outline-primary" v-on:click.prevent="loadWalletDetails">Retry</a>
                </span>
            </div>
        </template>

    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                remainingBalance: 0,
                withdrawRequests: null,

                // Loading flag
                loading: false,

                // Status flags
                success: false,
                fail: false,
            }
        },
        methods: {
            loadWalletDetails: function () {
                // Show the loading
                this.loading = true;

                // Clear previous flags
                this.success = false;
                this.fail = false;

                // Make a request to the API
                axios.get('/api/publisher/wallet')
                    .then(response => {
                        this.remainingBalance = response.data.balance;
                        this.withdrawRequests = response.data.withdraw_requests;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e =>{
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Publisher - Wallet mounted.');

            // Load wallet details
            this.loadWalletDetails();
        }
    }
</script>
